



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>单页面应用（SPA）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">单页面应用（SPA）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-17 04:19:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>此篇我们来瞅一瞅SPA，啥是SPA啊，实际上一点也不神秘，就是单页应用，可能有的同学又会问了，啥是单页面应用，别着急，我们慢慢来看</p>
<p>首先我们先来了解一下单页应用出现背景</p>
<p><strong>背景：</strong></p>
<p>在早期的 Web 应用中，前端的作用很弱，业务逻辑和数据处理都在后端，后端给前端返回一个 HTML 页面，前端只负责展示。在这种模式下，单个 HTML 页面被当做一个功能原件，表单提交，超链接跳转都可以用来重新请求新的 HTML 页面，从而达到给用户展示新的页面的目的。在这种方式中，你可以感觉到<strong>页面总是在不停的刷新</strong>，一个点击可能都需要等待很久，这是因为，当页面变化时，所有资源都需要重新请求。这些问题导致了用户体验不佳，也浪费了资源。单页应用便很好的解决了这些问题</p>
<p><strong>概念：</strong></p>
<p>什么是单页应用呢？单页应用的全称是 single-page application，简称 SPA，它是一种网站应用的模型，它可以动态重写当前的页面来与用户交互，而不需要重新加载整个页面。单页应用的流畅性让 Web 应用更像桌面端或 Native 应用了。相对于传统的 Web 应用，单页应用做到了前后端分离，后端只负责处理数据提供接口，页面逻辑和页面渲染都交给了前端。前端发展到现在，单页应用的使用已经很广泛，目前时兴的 React、Vue、Angular 等前端框架均采用了 SPA 原则。单页应用意味着前端掌握了主动权，也让前端代码更复杂和庞大，模块化、组件化以及架构设计都变得越来越重要</p>
<p><strong>工作原理:</strong></p>
<p>SPA 的一个重要实现就是改变路由时，页面不刷新。实现这个功能，通常有两种方式：使用 window.history 对象或 location.hash。</p>
<p>　　</p>
<p>　　window.history 包含了浏览器的历史信息，它有以下几种常用方法：</p>
<ul><li><ul><li><p>　　history.back()：与在浏览器点击后退按钮相同；</p></li></ul></li></ul>
<ul><li><ul><li><p>　　history.forward()：与在浏览器中点击按钮向前相同；</p></li></ul></li></ul>
<ul><li><ul><li><p>　　history.go(n)：接受一个整数作为参数，移动到该整数指定的页面，比如 go(1) 相当于 forward()，go(-1) 相当于 back()，go(0) 相当于刷新当前页面。</p></li>
<li><p>　　HTML5 对 history 对象新增了 pushState() 和 replaceState() 方法，这两个方法可以往历史栈中添加数据，给用户的感觉就是浏览器的 url 改变了，但是页面并没有重新加载。pushState() 是在浏览记录中添加一个新记录，replaceState() 则是修改当前的浏览器记录，这是二者的细微差别，使用时参数的字段和含义都是一样的。</p>
<p>window.history.pushState(state, title, url)</p></li></ul></li></ul>
<p>　　hash 是 location 对象的属性，它指的是当前 url 的锚，也就是从 # 号开始的部分。修改 location.hash 并监听 window 的 hashchange 事件，也能达到同样的目的。</p>
<p>　　　　SPA 可圈可点，现在已被大家广泛使用，也得到了主流框架的支持，但是它也有局限性，我们将它的优缺点总结如下。</p>
<p><strong>优缺点：</strong></p>
<p>　　优点有：</p>
<ul><li><p>无刷新体验，用户在切换页面过程中不会频繁被&ldquo;打断&rdquo;，因为界面框架都在本地，对用户的响应非常及时，因此提升了用户体验；</p></li></ul>
<ul><li><p>分离前后端关注点，前端负责界面显示，后端负责数据存储和计算，各司其职，不会把前后端的逻辑混杂在一起；</p></li></ul>
<ul><li><p>减轻服务器压力，服务器只用出数据就可以，不用管展示逻辑和页面合成，吞吐能力会提高几倍；</p></li></ul>
<ul><li><p>API 共享，同一套后端程序代码，不用修改就可以用于Web界面、手机、平板等多种客户端；</p></li></ul>
<ul><li><p>完全的前端组件化，前端开发不再以页面为单位，更多地采用组件化的思想，代码结构和组织方式更加规范化，便于修改和调整。</p></li></ul>
<p>　　缺点有：</p>
<ul><li><p>对&nbsp;SEO 不太优好，尽管可以通过&nbsp;<a href="https://prerender.io/" rel="external nofollow noreferrer">Prerender</a>&nbsp;预渲染优化等技术解决一部分，但是相对还是不容易索引到它；</p></li></ul>
<ul><li><p>易出错，需要使用程序管理前进、后退、地址栏等信息；</p></li></ul>
<ul><li><p>较高的前端开发门槛，对技术能力要求较高，需要对设计模式有一定理解，因为面对不是一个简单的页面，而是一个运行在浏览器环境里面的桌面软件。</p></li></ul>
<p><strong>　　转载自：https://www.yuque.com/fe9/basic/ag975a</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m9631d39.html">理解Cookie和Session机制&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q212eo8.html">&lbrack;转&rsqb;jni数据类型映射、域描述符说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96nv2jq.html">LA 4287 等价性证明</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jo2nlq.html">创建maven项目时，提示 overlaps the workspace location</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9prmw7q.html">遵循amd规范的require&period;js&lpar;适合浏览器端&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z0glxq.html">Android学习笔记之HttpClient实现Http请求&period;&period;&period;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1mk5k8.html">判断listview是上滑还是下滑的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1jgpr9.html">Inno Setup安装、卸载时判断是否程序正在运行</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1dyyr9.html">开发设计模式（二） ActiveObject模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wvewoq.html">由&period;Net类库提供的农历计算（C&num;农历）-获取当前日期的农历日期</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm3kge9.html">代码审查工具之PMD操作指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meex32q.html">&lbrack;leetcode&rsqb; Combination Sum and Combination SumII</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzlpve8.html">UVa455 Periodic String 的wronganswer问题探讨，以及AC的新思路</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4egxe9.html">小学四则运算编程&lpar;c&num;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj1ed79.html">Nginx reverse proxy NSQAdmin</a>
		</li>
						<li><a href="https://www.batexi.com/a/q255m4vq.html">AFNetWorking使用自签证书验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2e7kx9.html">C语言 矩阵的转置及矩阵的乘法</a>
		</li>
						<li><a href="https://www.batexi.com/a/96071r49.html">Django url管理之include</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvkwy28.html">ettercap中间人攻击--参数介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25o2lwq.html">ie兼容，手机端兼容问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j1d4yl9.html">visual studio单项目一次生成多框架类库、多框架项目合并</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o05wj8.html">Jquery - 添加属性、添加class、添加Css</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o05k18.html">Linux 查看IP</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw2rv48.html">Android Studio在项目中添加assets资源目录</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25yp6wq.html">使用docker redis-cluster集群搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zye0wx9.html">【Spark调优】数据本地化与参数调优</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j3rgnq.html">jmeter集合点使用方法&colon;Synchronizing Timer</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rwe228.html">request和response简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy0pkgq.html">【2019北京集训六】路径&lpar;path&rpar; 二分&plus;DP</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5kj5dq.html">Git使用教程：最详细、最傻瓜、最浅显、真正手把手教！</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
